diff -ruN ../nakedmudv2.7/src/set_val/set_val.h src/set_val/set_val.h
--- ../nakedmudv2.7/src/set_val/set_val.h	Sun Jul 31 17:13:51 2005
+++ src/set_val/set_val.h	Fri Oct  7 14:15:55 2005
@@ -22,6 +22,7 @@
 #define SET_CHAR           0
 #define SET_OBJECT         1
 #define SET_ROOM           2
+#define SET_ACCOUNT        3
 
 
 //
diff -ruN ../nakedmudv2.7/src/socials/socedit.c src/socials/socedit.c
--- ../nakedmudv2.7/src/socials/socedit.c	Sun Jul 31 17:13:51 2005
+++ src/socials/socedit.c	Fri Oct  7 14:15:55 2005
@@ -187,6 +187,6 @@
 // implementation of socedit.h
 //*****************************************************************************
 void init_socedit(void) {
-  add_cmd("socedit", NULL, cmd_socedit, 0, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("socedit", NULL, cmd_socedit, POS_UNCONCIOUS, POS_FLYING,
 	  "builder", FALSE, TRUE);
 }
diff -ruN ../nakedmudv2.7/src/socials/socials.c src/socials/socials.c
--- ../nakedmudv2.7/src/socials/socials.c	Sun Jul 31 17:13:51 2005
+++ src/socials/socials.c	Fri Oct  7 14:15:55 2005
@@ -92,14 +92,14 @@
 		       const char *to_room_tgt,
 		       int min_pos, int max_pos) {
   SOCIAL_DATA *data = malloc(sizeof(SOCIAL_DATA));
-  data->cmds          = strdup(cmds);
-  data->to_char_notgt = strdup(to_char_notgt ? to_char_notgt : "");
-  data->to_room_notgt = strdup(to_room_notgt ? to_room_notgt : "");
-  data->to_char_self  = strdup(to_char_self  ? to_char_self  : "");
-  data->to_room_self  = strdup(to_room_self  ? to_room_self  : "");
-  data->to_char_tgt   = strdup(to_char_tgt   ? to_char_tgt   : "");
-  data->to_vict_tgt   = strdup(to_vict_tgt   ? to_vict_tgt   : "");
-  data->to_room_tgt   = strdup(to_room_tgt   ? to_room_tgt   : "");
+  data->cmds          = strdupsafe(cmds);
+  data->to_char_notgt = strdupsafe(to_char_notgt);
+  data->to_room_notgt = strdupsafe(to_room_notgt);
+  data->to_char_self  = strdupsafe(to_char_self);
+  data->to_room_self  = strdupsafe(to_room_self);
+  data->to_char_tgt   = strdupsafe(to_char_tgt);
+  data->to_vict_tgt   = strdupsafe(to_vict_tgt);
+  data->to_room_tgt   = strdupsafe(to_room_tgt);
   data->min_pos       = min_pos;
   data->max_pos       = max_pos;
   return data;
@@ -161,14 +161,14 @@
   if(to->to_room_tgt)   free(to->to_room_tgt);
 
   // copy over all of the new descs and commands
-  to->cmds          = strdup(from->cmds          ? from->cmds          : "");
-  to->to_char_notgt = strdup(from->to_char_notgt ? from->to_char_notgt : "");
-  to->to_room_notgt = strdup(from->to_room_notgt ? from->to_room_notgt : "");
-  to->to_char_self  = strdup(from->to_char_self  ? from->to_char_self  : "");
-  to->to_room_self  = strdup(from->to_room_self  ? from->to_room_self  : "");
-  to->to_char_tgt   = strdup(from->to_char_tgt   ? from->to_char_tgt   : "");
-  to->to_vict_tgt   = strdup(from->to_vict_tgt   ? from->to_vict_tgt   : "");
-  to->to_room_tgt   = strdup(from->to_room_tgt   ? from->to_room_tgt   : "");
+  to->cmds          = strdupsafe(from->cmds);
+  to->to_char_notgt = strdupsafe(from->to_char_notgt);
+  to->to_room_notgt = strdupsafe(from->to_room_notgt);
+  to->to_char_self  = strdupsafe(from->to_char_self);
+  to->to_room_self  = strdupsafe(from->to_room_self);
+  to->to_char_tgt   = strdupsafe(from->to_char_tgt);
+  to->to_vict_tgt   = strdupsafe(from->to_vict_tgt);
+  to->to_room_tgt   = strdupsafe(from->to_room_tgt);
   to->min_pos       = from->min_pos;
   to->max_pos       = from->max_pos;
 }
@@ -223,37 +223,37 @@
 
 void socialSetCharNotgt(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_char_notgt) free(social->to_char_notgt);
-  social->to_char_notgt   = strdup(mssg ? mssg : "");
+  social->to_char_notgt   = strdupsafe(mssg);
 }
 
 void socialSetRoomNotgt(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_room_notgt) free(social->to_room_notgt);
-  social->to_room_notgt   = strdup(mssg ? mssg : "");
+  social->to_room_notgt   = strdupsafe(mssg);
 }
 
 void socialSetCharSelf(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_char_self) free(social->to_char_self);
-  social->to_char_self   = strdup(mssg ? mssg : "");
+  social->to_char_self   = strdupsafe(mssg);
 }
 
 void socialSetRoomSelf(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_room_self) free(social->to_room_self);
-  social->to_room_self   = strdup(mssg ? mssg : "");
+  social->to_room_self   = strdupsafe(mssg);
 }
 
 void socialSetCharTgt(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_char_tgt) free(social->to_char_tgt);
-  social->to_char_tgt   = strdup(mssg ? mssg : "");
+  social->to_char_tgt   = strdupsafe(mssg);
 }
 
 void socialSetVictTgt(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_vict_tgt) free(social->to_vict_tgt);
-  social->to_vict_tgt   = strdup(mssg ? mssg : "");
+  social->to_vict_tgt   = strdupsafe(mssg);
 }
 
 void socialSetRoomTgt(SOCIAL_DATA *social, const char *mssg) {
   if(social->to_room_tgt) free(social->to_room_tgt);
-  social->to_room_tgt   = strdup(mssg ? mssg : "");
+  social->to_room_tgt   = strdupsafe(mssg);
 }
 
 void socialSetMinPos(SOCIAL_DATA *social, int pos) {
@@ -451,16 +451,16 @@
   SOCIAL_DATA     *data = NULL;
 
   ITERATE_HASH(cmd, data, hash_i)
-    add_cmd(cmd, NULL, cmd_social, 0, data->min_pos, data->max_pos, 
+    add_cmd(cmd, NULL, cmd_social, data->min_pos, data->max_pos, 
 	    "player", TRUE, FALSE);
   deleteHashIterator(hash_i);
 
   // link/unlink commands for the admins
-  add_cmd("soclink", NULL, cmd_soclink, 0, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("soclink", NULL, cmd_soclink, POS_UNCONCIOUS, POS_FLYING,
 	  "builder", FALSE, FALSE);
-  add_cmd("socunlink", NULL, cmd_socunlink, 0, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("socunlink", NULL, cmd_socunlink, POS_UNCONCIOUS, POS_FLYING,
 	  "builder", FALSE, FALSE);
-  add_cmd("socials",   NULL, cmd_socials,   0, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("socials",   NULL, cmd_socials,   POS_UNCONCIOUS, POS_FLYING,
 	  "player",  TRUE, FALSE);
 
   // let add_social know it can start saving again
@@ -485,7 +485,7 @@
     unlink_social(cmd_list[i]);
     hashPut(social_table, cmd_list[i], social);
     // add the new command to the game
-    add_cmd(cmd_list[i], NULL, cmd_social, 0, social->min_pos, social->max_pos,
+    add_cmd(cmd_list[i], NULL, cmd_social, social->min_pos, social->max_pos,
 	    "player", TRUE, FALSE);
     free(cmd_list[i]);
   }
@@ -513,7 +513,7 @@
     hashPut(social_table, new_cmd, data);
     
     // add the new command to the game
-    add_cmd(new_cmd, NULL, cmd_social, 0, data->min_pos, data->max_pos,
+    add_cmd(new_cmd, NULL, cmd_social, data->min_pos, data->max_pos,
 	    "player", TRUE, FALSE);
   }
 
diff -ruN ../nakedmudv2.7/src/socket.c src/socket.c
--- ../nakedmudv2.7/src/socket.c	Sun Jul 31 17:13:53 2005
+++ src/socket.c	Fri Oct  7 14:15:55 2005
@@ -10,6 +10,8 @@
 #include <netdb.h>
 #include <sys/ioctl.h>
 #include <arpa/inet.h> 
+#include <zlib.h>
+#include <pthread.h>
 
 #include "mud.h"
 #include "character.h"
@@ -18,6 +20,7 @@
 #include "utils.h"
 #include "socket.h"
 #include "auxiliary.h"
+#include "hooks.h"
 
 
 
@@ -199,7 +202,7 @@
   text_to_buffer(sock_new, (char *) compress_will);
 
   /* send the greeting */
-  text_to_buffer(sock_new, greeting);
+  text_to_buffer(sock_new, bufferString(greeting));
   text_to_buffer(sock_new, "What is your account (not character) name? ");
 
   /* everything went as it was supposed to */
@@ -249,7 +252,7 @@
   }
   
   if(dsock->account)
-    deleteAccount(dsock->account);
+    unreference_account(dsock->account);
 
   /* set the closed state */
   dsock->closed = TRUE;
@@ -403,7 +406,7 @@
 void text_to_buffer(SOCKET_DATA *dsock, const char *txt)
 {
   static char output[8 * MAX_BUFFER];
-  bool underline = FALSE, bold = FALSE;
+  bool cr = FALSE, underline = FALSE, bold = FALSE;
   int iPtr = 0, last = -1, i = 0, j, k;
   int length = strlen(txt);
 
@@ -457,6 +460,16 @@
       default:
         output[iPtr++] = *txt++;
         break;
+      case '\r':
+	cr = TRUE;
+	output[iPtr++] = *txt++;
+	break;
+      case '\n':
+	if(cr == FALSE)
+	  output[iPtr++] = '\r';
+	output[iPtr++] = *txt++;
+	cr = FALSE;
+	break;
       case '{':
         i++; txt++;
 
@@ -876,7 +889,7 @@
     listPut(socket_list, dsock);
 
     // load account data
-    if((account = load_account(acct)) != NULL)
+    if((account = get_account(acct)) != NULL)
       socketSetAccount(dsock, account);
     // no luck!
     else {
@@ -886,7 +899,7 @@
     }
 
     // load player data
-    if ((dMob = load_player(name)) != NULL) {
+    if ((dMob = get_player(name)) != NULL) {
       // attach to socket
       charSetSocket(dMob, dsock);
       socketSetChar(dsock, dMob);
@@ -896,7 +909,7 @@
       if(!try_enter_game(dMob)) {
 	printf("Enter game failed.\r\n");
 	// do not bother extracting, since we haven't entered the game yet
-	deleteChar(socketGetChar(dsock));
+	unreference_player(socketGetChar(dsock));
 	socketSetChar(dsock, NULL);
 	close_socket(dsock, FALSE);
 	continue;
@@ -1109,6 +1122,9 @@
 
   sprintf(buf, "\n\r <*>            The world starts spinning             <*>\n\r");
 
+  // execute our shutdown hooks
+  hookRun("shutdown", NULL, NULL, NULL);
+
   // For each playing descriptor, save its character and account
   ITERATE_LIST(sock, sock_i) {
     compressEnd(sock, sock->compressing, FALSE);
@@ -1134,7 +1150,7 @@
 
   // close any pending sockets
   recycle_sockets();
-  
+
   // exec - descriptors are inherited
   sprintf(control_buf, "%d", control);
   sprintf(port_buf, "%d", mudport);
diff -ruN ../nakedmudv2.7/src/strings.c src/strings.c
--- ../nakedmudv2.7/src/strings.c	Sun Jul 31 17:13:54 2005
+++ src/strings.c	Fri Oct  7 14:15:55 2005
@@ -56,6 +56,39 @@
   return TRUE;
 }
 
+
+// same as one_arg, but can take constants
+const char *one_arg_safe(const char *fStr, char *bStr) {
+  /* skip leading spaces */
+  while (isspace(*fStr))
+    fStr++; 
+
+  /* copy the beginning of the string */
+  while (*fStr != '\0')
+  {
+    /* have we reached the end of the first word ? */
+    if (isspace(*fStr))
+    {
+      fStr++;
+      break;
+    }
+
+    /* copy one char */
+    *bStr++ = *fStr++;
+  }
+
+  /* terminate string */
+  *bStr = '\0';
+
+  /* skip past any leftover spaces */
+  while (isspace(*fStr))
+    fStr++;
+
+  /* return the leftovers */
+  return fStr;
+}
+
+
 char *one_arg(char *fStr, char *bStr)
 {
   /* skip leading spaces */
diff -ruN ../nakedmudv2.7/src/time/time.c src/time/time.c
--- ../nakedmudv2.7/src/time/time.c	Sun Jul 31 17:13:51 2005
+++ src/time/time.c	Fri Oct  7 14:15:55 2005
@@ -17,6 +17,7 @@
 #include "../event.h"
 #include "../storage.h"
 #include "../auxiliary.h"
+#include "../hooks.h"
 
 #include "mudtime.h"
 
@@ -30,6 +31,15 @@
 
 
 //*****************************************************************************
+// optional modules
+//*****************************************************************************
+#ifdef MODULE_SET_VAL
+#include "../set_val/set_val.h"
+#endif
+
+
+
+//*****************************************************************************
 // local defines, variables, and structs
 //*****************************************************************************
 #define TIME_FILE   "../lib/misc/time"  // where do we keep time data?
@@ -169,7 +179,7 @@
   ROOM_DATA *room = PyRoom_AsRoom(self);
   if(room == NULL) {
     PyErr_Format(PyExc_TypeError,
-		 "Tried to modify nonexistent room, %d", PyRoom_AsVnum(self));
+		 "Tried to modify nonexistent room, %d", PyRoom_AsUid(self));
     return -1;                                                                
   }
 
@@ -184,6 +194,18 @@
 //*****************************************************************************
 
 //
+// If it's in the night, swap out our desc for the room's night desc
+void room_nightdesc_hook(BUFFER *desc, ROOM_DATA *room, void *none) {
+  if((is_evening() || is_night()) && *roomGetNightDesc(room)) {
+    // if it's the room desc and not an edesc, cat the night desc...
+    if(!strcasecmp(bufferString(desc), roomGetDesc(room))) {
+      bufferClear(desc);
+      bufferCat(desc, roomGetNightDesc(room));
+    }
+  }
+}
+
+//
 // Handle the hourly update of our times
 //
 void handle_time_update(void *self, void *data, char *arg) {
@@ -247,9 +269,14 @@
   // add a nightdesc get-setter to rooms
   PyRoom_addGetSetter("ndesc", PyRoom_getndesc, PyRoom_setndesc,
 		      "the room's night desc");
+  
+  // add our set fields
+#ifdef MODULE_SET_VAL
+  add_set("ndesc", SET_ROOM, SET_TYPE_STRING, roomSetNightDesc, NULL);
+#endif
 
   // add the time command
-  add_cmd("time", NULL, cmd_time, 0, POS_SITTING,  POS_FLYING,
+  add_cmd("time", NULL, cmd_time, POS_SITTING,  POS_FLYING,
 	  "player", TRUE, FALSE);
 
   // add night descriptions for rooms
@@ -261,6 +288,7 @@
 
   // start our time updater
   start_update(NULL, TIME_UPDATE_DELAY, handle_time_update, NULL, NULL, NULL);
+  hookAdd("preprocess_room_desc", room_nightdesc_hook);
 }
 
 
